var Singleton = (function () {
    function Singleton(loader) {
        this.loader = loader;
        this.called = false;
    }
    Object.defineProperty(Singleton.prototype, "hasBeenCalled", {
        get: function () {
            return this.called;
        },
        enumerable: false,
        configurable: true
    });
    Singleton.prototype.get = function () {
        if (!this.called) {
            this.called = true;
            this.value = this.loader();
        }
        return this.value;
    };
    return Singleton;
}());
export { Singleton };
//# sourceMappingURL=singleton.js.map